
{$APPTYPE GUI}{$MODE DELPHI}

program demo89;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Optimize;

//const
 
//type 
  
var 
  vbo:GenVBO;
  texture:gluint;
  ang:glfloat;
  
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1,1, 0,1, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
end;
begin 

  OpenGL_Texture();
  
  GenTexTerrain(0,35,45,120, 3, 'terreno-test00-big.bmp','water4.bmp','Floor04.bmp','Floor09.bmp','WP25.bmp',texture);
  
  vboGenTerrain(vbo,0.15,2.25, 4, 1,'terreno-test00.bmp');
  vbo.SetVBO;  
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  SetNewIntervalFps(FPS_ONE_SECOND); // reimposta l'intervallo ad un frame al secondo 
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(30,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,20,0, 0.1); 

  glRotatef(120,0,-1,0); 
  
  glBindTexture(GL_TEXTURE_2D,texture);

  glMatrixMode(GL_TEXTURE);
  glPushMatrix;  
  glRotatef(-180,0,1,0);		
  glRotatef(90,0,0,1);
  
  vbo.Draw(GL_TRIANGLES); 
  
  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);	
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Generazione di texture composita per un terreno', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 SetglTimer(FPS_TIMER,FPS_ONE_SECOND); // timer per fps
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 //Setglmsg();
 SetglmsgWithFPS(dcWindow,OpenGL_Draw); // gestione con calcolo di fps 

 //OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 ///SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
